/*
// convertlib.h

// This is all the library functions that are used in convertion files
// This file will grow as new convertions are implemented
// Last Modified: 4-2-97
*/

/**************/
/*  Includes  */
/**************/

#include <stdio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#include "../include/libPIF.h" /* This includes common.h */
extern void map_write_brant();

#define MAXINT 2147483647  
#define MAXSHORT 65535
#define MAXIMAGES 2000  

#define APPEND 22

typedef struct __tifTag_t__
  {/* tifTag_t */
    int    tagid;
    int    dataType;
    int    dataCount;
    int    dataOffset;
  }/* tifTag_t */ tifTag_t;


extern void exit();
extern void *malloc();
extern void *calloc();
extern double strtod();
extern double sqrt();

extern void img_stats();
extern void img_write();

extern void free();

extern void mainEmimg_sub(); 
extern void img_write_recl_open_rob();
extern void read_bp(); 
extern void write_bp(); 
extern void open_bp(); 


#define IMAGE              32   /* Keep these off the same bits so we can   */
#define PACKED             64   /* bitwise AND them (&)                     */
#define ALL                2
#define MAP                16
#define PORTABLE           128
#define PACKEDPORTABLE     4    /* NOT the same as PACKED here */
#define TIFF               8
#define BP                 9

fString_t fileName;

int mode,readendianSwitch=FALSE,writeendianSwitch=FALSE;
int intNcol, intNrow, lun;
int readSize,writeSize,em_wrt,choice;

int endianSwitch,bpSwitch,odSwitch,floatSwitch;
int reverseSwitch,largeSwitch;
int fileType;


float floatScaleFactor;
float recipFloatScaleFactor;

float junkFloat;

int img_min,img_max,img_bkg;
int numCols,numRows,numSecs;
int backGrounds[MAXIMAGES];
int imgMins[MAXIMAGES],imgMaxs[MAXIMAGES];
float img_avg,img_std,aoverb,map_abang,map_scalef;
float imgAvgs[MAXIMAGES],imgStds[MAXIMAGES];
int nimg,nrec_last,bimg_sizes,asked;
int inHeight,inWidth,maxInWidth;
int headOff,thisOffset,htype,endianNess,imgOffset,mapOffset;
char versionStr[32],descriptionStr[80],timeStr[32],micrographStr[16],
     scanNumberStr[8],floatScaleStr[17];

BYTE *byte_buffer;
short *short_buffer;
float *float_buffer;

int rec_length, nrecords, nrows_per_record;
int nrecords_per_row, numRecs, recLength, totLength;
int mrc_nx, mrc_ny, mrc_nz, mrc_mode;
int mrc_nxstart, mrc_nystart, mrc_nzstart;
int mrc_mx, mrc_my, mrc_mz, mrc_mapc, mrc_mapr, mrc_maps;
int mrc_ispg, mrc_nsymbt;
int mrc_extra[29], mrc_nlabl, mrc_label[20][10], mrc_rec;
int    mrc_xlength, mrc_ylength, mrc_zlength;
int    mrc_alpha, mrc_beta, mrc_gamma;
int    mrc_min, mrc_max, mrc_mean, mrc_std, mrc_xorigin, mrc_yorigin;
float    rows_per_record, records_per_row;
char inFilename[164],outFilename[128];

float aoverb, map_abang, map_scalef, a_cell,b_cell,
      c_cell, alp, bet, gam, dela, delb, delc;
float map_max,map_min;
int t_matrix[6];
int packRadius;

/* Tiff file parameters */
int bitsPerSample, compression, pmi, orientation, samplesPerPixel,
  planarConfig, tileWidth,tileLength, tileOffsets,tileByteCounts,RowsPerStrip,
  StripByteCounts,StripOffsets;
int tileByteCountsType,StripByteCountsType,StripOffsetsType,tiles,strips;
int tilesInImage,tilesAcross,tilesDown,StripsInImage;


/**************/
/*  Functions */
/**************/


/*********************************************************
 * diffEndian() - Convert this to a different ENDIAN
 * bit of memory. 
*/
void diffEndian(BYTE *inStr, int length )
{/* DIFFENDIAN */
  int i,lm1;
  BYTE thisStr[8];

  for(i=0;i<length;i++)
    *(thisStr + i)= *(inStr + i);
  lm1= length - 1;
  for(i=0;i<length;i++)
    *(inStr + i) = (*(thisStr + (lm1-i)) & 0377);

}/* DIFFENDIAN */


/******************************************************************
 * determineFileType() -
*/
void determineFileType(FILE *fIn)
{/* DETERMINEFILETYPE */
  short junk1,junk2;
  BYTE byte1,byte2;
  int file_id1,file_id2;

  /* Read the file type header */
  if(endianSwitch)
    {/* This was captured on an SGI maybe */
      fread(&file_id1,sizeof(int),1,fIn); 
      fread(&file_id2,sizeof(int),1,fIn); 
      printf("[%3d]  ",file_id1);
      printf("\n");
      printf("[%3d]  ",file_id2);
      printf("\n");
#ifdef DEBUG  // Use this for debugging purposes
      fread(&byte1,sizeof(BYTE),1,fIn); 
      printf("[%3d]  ",byte1);
      fread(&byte1,sizeof(BYTE),1,fIn); 
      printf("[%3d]  ",byte1);
      fread(&byte1,sizeof(BYTE),1,fIn); 
      printf("[%3d]  ",byte1);
      fread(&byte1,sizeof(BYTE),1,fIn); 
      printf("[%3d]  ",byte1);
      fread(&byte1,sizeof(BYTE),1,fIn); 
      printf("[%3d]  ",byte1);
      fread(&byte1,sizeof(BYTE),1,fIn); 
      printf("[%3d]  ",byte1);
      fread(&byte1,sizeof(BYTE),1,fIn); 
      printf("[%3d]  ",byte1);
      fread(&byte1,sizeof(BYTE),1,fIn); 
      printf("[%3d]  ",byte1);
      printf("\n");
#endif /* #ifdef DEBUG */

    }/* This was captured on an SGI maybe */
  else
    {/* Non SGI */
      fread(&junk1,sizeof(unsigned short),1,fIn); 
      fread(&file_id1,sizeof(int),1,fIn); 
      fread(&junk2,sizeof(unsigned short),1,fIn); 
      
      file_id2= 0;
      if(endianSwitch)
	{/* Backwards */
	  file_id2 |= ((junk1 & 0377) << 8);
	  file_id2 |= ((junk1 & 0177400) >> 8);
	  file_id2 |= ((file_id1 & 077600000)
		       << 8);
	  file_id2 |= ((file_id1 & 037700000000)
		       >> 8);
	  
	}/* Backwards */
      else
	{/* "normal " */
	  file_id2 |= junk1;
	  file_id2 |= (((file_id1) & 
			0177777) << 16);
	}/* "normal " */
      
      diffEndian((BYTE *)&file_id1, 4);
      /* Already handled this above 
	 diffEndian((BYTE *)&file_id2, 4);
	 */
    }/* Non SGI */
  
  /* What type of image is it??? */
  fileType = 0;
  if(file_id1==-1)
    fileType |= IMAGE;
  if (file_id1==-3)
    fileType |= MAP;
  if(file_id2==-10)
    fileType |= PACKED;
  if(file_id1==-32)
    fileType |= PORTABLE;
  if(file_id2==-64)
    fileType |= PACKEDPORTABLE;
  if(file_id1==1744972288)
    fileType = TIFF;
  if(file_id1==704662861)
    fileType = TIFF;
  if(file_id2==704662861)
    fileType = TIFF;
  if(bpSwitch)
    fileType = BP;
  
  
}/* DETERMINEFILETYPE */



/*********************************************************************
 * writeBPfile() - 
*/
void writeBPfile(char *outFileName)
{/* WRITEIMAGE */
  char firstImg[32],lastImg[32];
  int i,j,firstI,lastI;

#ifdef VMS
  printf("\n\nThere are [%d] images in the packed file.\n",nimg);
  printf("\tNumbered from [0-%d]\n\n",(nimg-1));
  printf("First image to write [1]- ");
  fflush(stdout);
  gets(firstImg);
  printf("Last image to write [%d]- ",(nimg));
  fflush(stdout);
  gets(lastImg);
  firstI= (int)strtod(firstImg,0);
  if(firstI > 0)
    firstI--;
  if(strcmp(lastImg,"")==0)
    lastI= nimg;
  else lastI= (int)strtod(lastImg,0); 
  for(i=firstI;i<lastI;i++)
    {/* Write the file */
      sprintf(fileName.addr,"%s_%03d.bp",outFileName,(i+1));
      printf("%s [%d][%d]\n",fileName.addr,numCols,numRows);
      /* Use Fortran function in gatsubs.for to write the bp file */
      write_bp(&fileName, (byte_buffer+(i*numCols*numRows)), 
				&numCols, &numRows);
    }/* Write the file */
#else
  printf("Writing BP files only available for VMS for now...\n");
#endif

}/* WRITEBPFILE */



/*********************************************************************
 * readPacked() - 
*/
void readPacked(FILE *fIn)
{/* READPACKED */
  int file_id,done,restBufLength,logicalRecordLength,m,k,l,thisBkg;
  short shortJunk;
  unsigned char inBuf[2048];
  char title [256];
  int writeSize;
  char s1[1256];

  if(fIn)
    {/* it is readable */
      float modVal;
      
      /* This is our UNIX attempt to read Purdue packed
       * format .PCK for development in UNIX
       */
      /* Read off the rest of the 512 byte record */
      fread(s1,sizeof(char),504,fIn);  
      
      fread(&nimg,sizeof(int),1,fIn);  
      fread(&nrec_last,sizeof(int),1,fIn);  
      fread(&bimg_sizes,sizeof(int),1,fIn);  
      if(!bimg_sizes)
	{/* We don't know how to do this yet */
	  printf("Can't do a packed file with differing image sizes [%d]\n",
		 bimg_sizes);
	  exit(0);
	}/* We don't know how to do this yet */
      
      /* Read off the rest of the 512 byte record */
      fread(s1,sizeof(char),500,fIn);  
      
      /* Get title but include the rest of the 512 byte record */
      fread(s1,sizeof(char),512,fIn);
      memcpy(descriptionStr,s1,64);
      
      fread(&img_bkg,sizeof(short),1,fIn);
      fread(&numCols,sizeof(short),1,fIn); 
      fread(&numRows,sizeof(short),1,fIn);
      
      printf("numCols[%d]rows[%d]\n",numCols,
	     numRows);
      fread(&img_min,sizeof(int),1,fIn);
      fread(&img_max,sizeof(int),1,fIn);
      
      /* FORTRAN on VMS writes it's own version of what
       * it thinks a float ought to be - we will using ASCII
       * character STRINGS in future to insure portablility
       * among differing computer systems 
       */
#ifdef FIGUREOUTFORTRAN_FLOATS
      fread(&img_avg,sizeof(float),1,fIn);
      fread(&img_std,sizeof(float),1,fIn);
#else
      fread(&img_avg,sizeof(int),1,fIn);
      fread(&img_std,sizeof(int),1,fIn);
#endif
      
      /* Read off the rest of the 512 byte record */
      fread(s1,sizeof(char),490,fIn);  
      
      /* Figure out how we're going to display these
       * puppies on the screen - e.g. how many images
       * per row etc...
       */
      done= FALSE;

      /* Now calc how much of the last 512 byte buffer will
       * be left after we've read all the image data */
      restBufLength = 512 - ((numCols * numRows) % 512);
      
      if(byte_buffer != NULL)
	free(byte_buffer);
      byte_buffer = (BYTE *)malloc(sizeof(BYTE)*
					     ((numCols*numRows)*nimg));
      
      /* This is the length of each record read */
      logicalRecordLength = numCols * numRows;
      
      /* Now read the "meat" of all the images
       * in the PACKED file */
      for(m=0;m<nimg;m++) 
	{/* Do all images */
	  for(k=numRows-1;k>=0;k--)
	    {/* Read it a row at a time */
	     /* Do this from the last line to the first because the image */
	     /* is read as though the point (0,0) is at top left but actual */
	     /* image has origin at bottom left so we need to flip the image */
	      fread((byte_buffer+(numRows*numCols*m)+(k*numCols)),
		    sizeof(BYTE),(numCols),fIn);
	    }/* Read it a row at a time */

	  /* Read off the rest of the last 512 byte record */
	  fread((inBuf),
		sizeof(unsigned char),(restBufLength),fIn);
	  
	  /* Read off this 512 byte record */
	  fread((inBuf),
		sizeof(unsigned char),(512),fIn);
	  /* Read off this 512 byte record */
	  fread((inBuf),
		sizeof(unsigned char),(512),fIn);

	  /******************************************************
	   * We should be able to pick up new image sizes here
	   * for files that have varying image sizes in the 
	   * packed file.
	   ******************************************************/
#ifdef GETTHISTOWORK
	  /* We're implementing that all images are the same
	   * size.  Need to change this in future as it may
	   * not be so.  So for now we need to read the numCols/numRows
	   * record for the next image.
	   */
	  fread(&img_bkg,sizeof(short),1,fIn);
	  fread(&numCols,sizeof(short),1,fIn); 
	  fread(&numRows,sizeof(short),1,fIn);
	  
	  printf("numCols[%d]rows[%d]\n",numCols,
		 numRows);
	  fread(&img_min,sizeof(int),1,fIn);
	  fread(&img_max,sizeof(int),1,fIn);
	  
	  fread(&img_avg,sizeof(int),1,fIn);
	  fread(&img_std,sizeof(int),1,fIn);
	  
	  
	  /* Read off the rest of the 512 byte record */
	  fread(s1,sizeof(char),492,fIn);  
	  
#endif
	  thisBkg= *(byte_buffer+(numRows*numCols*m));
	  /* printf("thisBkg pixel = %d\n",thisBkg); */
	  /* Now float it */
	  if(floatSwitch)
	    {/* Float */
	      for(k=0;k<numRows;k++)
		{/* Read it a row at a time */
		  for(l=0;l<numCols;l++)
		    {/* Read it a col at a time */
		      *(byte_buffer+(numRows*numCols*m)+(k*numCols)+l) -= 
					thisBkg;
		      
		    }/* Read it a col at a time */
		}/* Read it a row at a time */
	    }/* Float */

	}/* Do all images */


    }/* It is readable */
  else
    {/* Error */
      printf("Can't open input file [%s]\n",inFilename);
      exit(0);
    }/* Error */


}/* READPACKED */





/**************************************************************
 * calcBackground() - Calculate statistics about the image.
 * Used by the stuffDisplayBoxBuffer() routine(s) to mask the
 * background of the boxed images.
*/
int calcBackground(BYTE *inBuf, int width, int height, int boxWidth )
{/* CALCBACKGROUND */
  int i,j,totPnts,xcen,ycen,iMycen,jMxcen,thisRadius;
  float absTmp,back,std,avg,var,sumSq,distnce,cutOff,tmp,xSq,ySq;
  float recipSizeFactor;
  BYTE b1,b2;

  /* Init the background value */
  back = 0.0;
  thisRadius = width / 2;    /* Assume square */

  /* Assume we've not zoomed this puppy */
  recipSizeFactor = 1.0;

  /* Which method do they want? */
  sumSq = 0.0;
  back = 0.0;
  /* Calc for circle boxes */
  xcen = ycen = thisRadius;
  totPnts = 0;
  for(i=0;i<height;i++)
    for(j=0;j<width;j++)
      {/* Look at all pixels */
	
	b1= inBuf[((i*boxWidth)+j)];
	iMycen = (i*recipSizeFactor)-ycen;
	jMxcen = (j*recipSizeFactor)-xcen;
	xSq= (iMycen)*(iMycen);
	ySq= (jMxcen)*(jMxcen);
	distnce = (float)sqrt((double)(xSq+ySq)); 
	if(distnce>=thisRadius && ((distnce-1.0)<= thisRadius))
	  {/* we've found one on the thisRadius */
	    tmp  =  (float)b1;
	    back += tmp;
	    totPnts++;
	    sumSq += (float)((float)tmp*(float)tmp);
	  }/* we've found one on the thisRadius */
      }/* Look at all pixels */
  
  std     = 0.0;
  avg = 0.0;
  if(totPnts > 0)
    {/* OK to do */
      avg     = back/totPnts;
      var     = (sumSq/totPnts) - (avg*avg);
      if(var >= 0.0) 
	std = sqrt(var);
    }/* OK to do */
  
  /*'****************************************************'
   *'*  Throw out data points more than 2*STD from AVG  *'
   *'****************************************************'*/
  back   = 0.0;
  totPnts = 0;
  sumSq  = 0.0;
  
  /* We need to throw away the "dark" stuff because that is
   * likely where the adjoining particle is contributing to our
   * concept of background */
#ifdef ORIG_ROWKS
  cutOff= avg + (2.0*std);
#else
  cutOff= avg - (2.0*std);
#endif
  for(i=0;i<height;i++)
    for(j=0;j<width;j++)
      {/* Look at all pixels */
	b1 = inBuf[((i*boxWidth)+j)];
	tmp= (float)b1;
	iMycen = (i*recipSizeFactor)-ycen;
	jMxcen = (j*recipSizeFactor)-xcen;
	xSq= (iMycen)*(iMycen);
	ySq= (jMxcen)*(jMxcen);
	distnce = (float)sqrt((double)(xSq+ySq)); 
	if(distnce>=thisRadius && ((distnce-1.0)<= thisRadius))
	  {/* we've found one on the thisRadius */
	    if(tmp < avg)
	      absTmp = avg + (avg - (float)tmp);
	    else absTmp = (float)tmp;
#ifdef ORIG_ROWKS
	    if(absTmp <= cutOff) 
#else
	      if(absTmp > cutOff) 
#endif
		{/* then       */
		  back   += tmp;
		  totPnts++;
		  sumSq  += (tmp*tmp);
		}/* then       */
	  }/* we've found one on the thisRadius */
      }/* Look at all pixels */
  
  std = 0.0;
  avg = 0.0;
  if(totPnts > 0)
    {/* OK to do */
      avg = back/totPnts;
      var = (sumSq/totPnts) - (avg*avg);
      if(var >= 0.0) 
	std = sqrt(var);
    }/* OK to do */
  
  back = (int)(avg);
  
  return((int)back);
			    
}/* CALCBACKGROUND */





/**************************************************************
 * calcRectBackground() - Calculate statistics about the 
 * RECTABGULAR image.
*/
int calcRectBackground(BYTE *inBuf, int width, int height, int boxWidth )
{/* CALCRECTBACKGROUND */
  int i,j,totPnts,xcen,ycen,iMycen,jMxcen,thisRadius;
  float absTmp,back,std,avg,var,sumSq,distnce,cutOff,tmp,xSq,ySq;
  float recipSizeFactor;
  BYTE b1,b2;

  /* Init the background value */
  back = 0.0;

  /* Which method do they want? */
  sumSq = 0.0;
  back = 0.0;
  totPnts = 0;
  for(i=0;i<height;i++)
    for(j=0;j<width;j++)
      {/* Look at all pixels */
	
	b1= inBuf[((i*boxWidth)+j)];
	if(i==0 || j==0 || (i==(height-1)) || (j==(width-1)))
	  {/* we've found one on the thisRadius */
	    tmp  =  (float)b1;
	    back += tmp;
	    totPnts++;
	  }/* we've found one on the thisRadius */
      }/* Look at all pixels */
  
  if(totPnts > 0)
    {/* OK to do */
      avg     = back/totPnts;
    }/* OK to do */
  
  return((int)back);
			    
}/* CALCRECTBACKGROUND */





/***************************************************
 * calcStats() - Calculates statistics from the image
*/
calcStats(BYTE *inbuffer, int *img_bkg, int *img_min,
	  int *img_max, float *img_avg, float *img_std,
	  int width, int height, int sampleBkg)
{/* CALCSTATS */
  int i,j;
  int pixelValue,tot;
  float totValues;
  double var,sumsq;

printf("wid[%d]  he[%d]\n",width,height);

  *img_bkg = 0;
  *img_min = inbuffer[0];
  *img_max = inbuffer[0];
  *img_avg = 0;
  *img_std = 0;
  sumsq = 0.0;
  totValues = tot = 0;
  for(i=0;i<height;i++)
    for(j=0;j<width;j++)
      {/* Look at all pixels */
	pixelValue = (int)inbuffer[((i*width)+j)];
	*img_min = MIN(*img_min,pixelValue);
	*img_max = MAX(*img_max,pixelValue);
	if(pixelValue > 0)
	  {/* Only use non-zeros */
	    sumsq += (pixelValue * pixelValue);
	    totValues +=  (float)pixelValue;
	    tot++;
	  }/* Only use non-zeros */
      }/* Look at all pixels */

  if(sampleBkg)
    *img_bkg = inbuffer[0];
  else if(sampleBkg==99)
    *img_bkg= (short)calcRectBackground(inbuffer, width, height, width );
  else /* Calc the background */
    *img_bkg= (short)calcBackground(inbuffer, width, height, width );

  /* img_avg = summation of all pixelValues / total number of pixels */
  *img_avg = (float)((float)totValues / (float)(tot));
  *img_std = 0.0;
  var = (sumsq / (float)(tot)) - (*img_avg * *img_avg);
  if(var > 0.0)
    *img_std = (float)sqrt(var);
  printf("calcStats bkg[%d] avg[%f] std[%f] min[%d] max[%d]\n",
	 *img_bkg,
	 *img_avg, *img_std,
	 *img_min,*img_max);

}/* CALCSTATS */


/****************************************************************
 * calcShortStats() - Calculates statistics from the short image
 * from the disk.
*/
void calcShortStats(unsigned short *inbuffer, int *img_bkg, int *img_min,
	  int *img_max, float *img_avg, float *img_std,
	  int width, int height, int boxWidth)
{/* CALCSHORTSTATS */
  int i,j;
  int pixelValue,tot;
  float totValues;
  double var,sumsq;

  /* Init all */
  *img_bkg = 0;
  *img_min = inbuffer[0];
  *img_max = inbuffer[0];
  *img_avg = 0;
  *img_std = 0;

  /* Accumulate intermediate values */
  totValues = tot = 0;
  var = sumsq = 0.0;
  for(i=0;i<height;i++)
    {/* height */
      for(j=0;j<width;j++)
	{/* Look at all pixels */
	  pixelValue = (int)inbuffer[((i*boxWidth)+j)];
	  if(pixelValue > 0)
	    {/* Only use non-zeros */
	      *img_min = MIN(*img_min,pixelValue);
	      *img_max = MAX(*img_max,pixelValue);
	      sumsq += (pixelValue * pixelValue);
	      totValues +=  (float)pixelValue;
	      tot++;
	    }/* Only use non-zeros */
	}/* Look at all pixels */
/* printf("[%d][%d] - %d\n",i,22,(int)inbuffer[((i*boxWidth)+22)]); */
    }/* height */
  
  /* Calc the background */
  *img_bkg= (int)inbuffer[0];

  /* Calc stats */
  *img_avg = (float)((float)totValues / (float)(width * height));
  *img_std = 0.0;
  var = (sumsq / (float)(width*height)) - (*img_avg * *img_avg);
  if(var > 0.0)
    *img_std = (float)sqrt(var);

}/* CALCSHORTSTATS */



/********************************************************
 * calcMapShortStats() - Calculates statistics from the MAP.
*/
void calcMapShortStats(short *inbuffer, int *img_bkg, int *img_min,
	  int *img_max, float *img_avg, float *img_std,
	  int width, int height, int nSecs)
{/* calcMapStats */
  int i,j,k;
  int pixelValue,tot;
  float totValues;
  double var,sumsq;

  /* Init all */
  *img_bkg = 0;
  *img_min = inbuffer[0];
  *img_max = inbuffer[0];
  *img_avg = 0;
  *img_std = 0;

  /* Accumulate intermediate values */
  totValues = tot = 0;
  var = sumsq = 0.0;
  for(k=0;k<nSecs;k++)
    {/* Do all secs */
      for(i=0;i<height;i++)
	{/* height */
	  for(j=0;j<width;j++)
	    {/* Look at all pixels */
	      pixelValue = (int)inbuffer[((k*height*width)+(i*width)+j)];
	      /* Use non-zeros also */
	      *img_min = MIN(*img_min,pixelValue);
	      *img_max = MAX(*img_max,pixelValue);
	      sumsq += (pixelValue * pixelValue);
	      totValues +=  (float)pixelValue;
	      tot++;
	    }/* Look at all pixels */
	}/* height */
    }/* Do all secs */
  
  /* Calc the background */
  *img_bkg= (short)inbuffer[2];   /* Bkg in the first section */

  /* Calc stats */
  *img_avg = (float)((float)totValues / (float)(width * height *nSecs));
  *img_std = 0.0;
  var = (sumsq / (float)(width*height*nSecs)) - (*img_avg * *img_avg);
  if(var > 0.0)
    *img_std = (float)sqrt(var);

}/* calcMapShortStats */


/************************************************************
 * today() - Return todays date and current time in STRING 
 * (static) form.
*/
char *today()
{/* TODAY */
  static char s1[132];
  char *sR, *ampm;
  int seconds,
      datec,
      timeofday,
      minutes,
      hours,
      hyear,
      hmonth,
      hday;
#ifdef VMS
  tm_t *tim;
#else
  struct tm *tim;
#endif
  time_t tSec;

  tSec= time(NULL); 
  tim= localtime((time_t *)&tSec); 

  seconds= tim->tm_sec;
  minutes= tim->tm_min;
  hours=   tim->tm_hour;
  hday=    tim->tm_mday;
  hmonth=  tim->tm_mon + 1;
  hyear=   tim->tm_year + 1900;

  if(hours > 12)
    {/* PM */
      hours -= 12;
      ampm= "PM";
    }/* PM */
  else if(hours==12)
    ampm= "PM";
  else ampm= "AM";

  sprintf(s1,"%02d/%02d/%04d,  %02d:%02d:%02d%s",
         hmonth, hday, hyear, hours, minutes, seconds, ampm);

  return(s1);
}/* TODAY */



/*************************************************************
 * calcScaleFactor() - Calculate the factor needed to convert
 * out floatIntegers into floats when we read this file later.
 * Just scan all of our values and pick a value that maintains 
 * out dynamic rarenge.
*/
void calcScaleFactor(float *floatScaleFactor, 
		     float *recipFloatScaleFactor, 
		     int img_min, int img_max,
		     float img_avg, float img_std)
{/* CALCSCALEFACTOR */
  float minVal,maxVal;

  minVal= img_avg;
  maxVal= img_avg;

  minVal= MIN(minVal,img_min);
  minVal= MIN(minVal,img_max);
  minVal= MIN(minVal,img_avg);
  minVal= MIN(minVal,img_std);

  maxVal= MAX(maxVal,img_min);
  maxVal= MAX(maxVal,img_max);
  maxVal= MAX(maxVal,img_avg);
  maxVal= MAX(maxVal,img_std);

  /* Get greatest magnitude */
  if(minVal < 0.0)
    minVal = 0.0 - minVal;
  maxVal = MAX(minVal,maxVal);

  *floatScaleFactor = (float)((float) MAXINT / (float) maxVal);
  *recipFloatScaleFactor = (float)(1.0 / *floatScaleFactor); 

}/* CALCSCALEFACTOR */


/*************************************************************
 * calcShortScaleFactor() - Calculate the factor needed to convert
 * out floatIntegers into floats when we read this file later.
 * Just scan all of our values and pick a value that maintains 
 * out dynamic rarenge.
*/
void calcShortScaleFactor(float *floatScaleFactor, 
		     float *recipFloatScaleFactor, 
		     int img_min, int img_max,
		     float img_avg, float img_std)
{/* CALCSHORTSCALEFACTOR */
  float minVal,maxVal;

  minVal = -360.0; /* Account for alp,bet,gam */
  maxVal = 360.0;

  minVal= MIN(minVal,img_min);
  minVal= MIN(minVal,img_max);
  minVal= MIN(minVal,img_avg);
  minVal= MIN(minVal,img_std);

  maxVal= MAX(maxVal,img_min);
  maxVal= MAX(maxVal,img_max);
  maxVal= MAX(maxVal,img_avg);
  maxVal= MAX(maxVal,img_std);

  /* Get greatest magnitude */
  if(minVal < 0.0)
    minVal = 0.0 - minVal;
  maxVal = MAX(minVal,maxVal);

  *floatScaleFactor = (float)((float) MAXSHORT / (float) maxVal);
  *recipFloatScaleFactor = (float)(1.0 / *floatScaleFactor); 

}/* CALCSHORTSCALEFACTOR */


/*********************************************************
 * convert- takes an input short along with a min and max 
 * value and returns the scaled version of that input 
 * value. 
*/
BYTE convert(short input,short max,short min) {
  short scalefactor;

  scalefactor = 255/(max-min);
  return((input-min)*scalefactor);
}


/**********************************************************
 * write_apx- writes an axp using the filename and the mode
 * to determine how to write it
*/
void write_apx(char *filename,int mode) {
  FILE *fp;
  char ans;
  BYTE background;
  BYTE temp;
  short min,max;
  int x,y,n;

  if ((fp=fopen(filename,"r"))) {
    fclose(fp);
    printf ("File already exists. Do you wish to overwrite it? ");
    scanf("%c",&ans);
    if (toupper(ans)=='Y')
      fp=fopen(filename,"w");
    else 
      exit(0); 
  }
  else {
    fclose(fp);
    fp=fopen(filename,"w");
  }
  printf ("Ncol[%d] Nrow[%d]\n",numCols,numRows);
  if (mode==0 || mode==6)
    background = byte_buffer[0];    
  else if (mode==1) {
    min=max=short_buffer[0];
    for (x=0;x<numCols*numRows;x++) {
      if (short_buffer[x] < 100)
        printf ("%d:%d ",x,short_buffer[x]);
      max = MAX(short_buffer[x],max);
      min = MIN(short_buffer[x],min);
    }
    printf ("min[%d] max[%d]\n",min,max);
    background = convert(short_buffer[0],max,min);    
  }
  if (numRows<=512) { /* If height is too small */
    printf ("Height is too small\n");
    if (numCols<=512) { /* If width is too small */
      printf ("Width is too small\n");
      for (n=0;n<(512*(256-numRows/2));n++)
        fwrite(&background,sizeof(BYTE),1,fp);
      for (y=0;y<numRows;y++) {
        for (n=0;n<(256-numCols/2);n++)
          fwrite(&background,sizeof(BYTE),1,fp);
        for (x=0;x<numCols;x++)
          if (mode==0 || mode==6) 
            fwrite(&byte_buffer[y*numCols+x],sizeof(BYTE),1,fp);
          else if (mode==1)
            fwrite(&short_buffer[y*numCols+x],sizeof(short),1,fp);
        for (n=0;n<(256-numCols/2-numCols%2);n++)
          fwrite(&background,sizeof(BYTE),1,fp);
      } /* End for each row */
      for (n=0;n<(512*(256-numRows/2-numCols%2));n++)
        fwrite(&background,sizeof(BYTE),1,fp);
    } /* End if width too small */
    else { /* Width is too big */
      printf ("Width is too big\n");
      for (n=0;n<(256-numRows/2)*512;n++)
        fwrite(&background,sizeof(BYTE),1,fp);
      for (y=0;y<numRows;y++) 
        for (x=0;x<512;x++) 
          if (mode==0 || mode==6)
            fwrite(&byte_buffer[y*512+x+(numCols-512)/2],sizeof(BYTE),1,fp);   
          else if (mode==1)
            fwrite(&short_buffer[y*512+x+(numCols-512)/2],sizeof(short),1,fp);  
      for (n=0;n<(512*(256-numRows/2-numCols%2));n++)
        fwrite(&background,sizeof(BYTE),1,fp);
    } /* End width is too big */
  } /* if height is too small */ 
  else { /* if height is too big */
    printf ("Height is too big\n");
    if (numCols<=512) { /* Width is too small */
      printf ("Width is too small\n");
      for (y=0;y<512;y++) {
        for (n=0;n<(numCols-512)/2;n++)
          fwrite(&background,sizeof(BYTE),1,fp);
        for (x=0;x<numCols;x++) 
          if (mode==0 || mode==6)
            fwrite(&byte_buffer[(y+(numRows-512)/2)*512+x],
                   sizeof(BYTE),1,fp);     
          else if (mode==1)
            fwrite(&short_buffer[(y+(numRows-512)/2)*512+x],
                   sizeof(short),1,fp);     
        for (n=0;n<(numCols-512)/2-numCols%2;n++)
          fwrite(&background,sizeof(BYTE),1,fp);
      }
    } /* End width is too small */
    else { /* width is too big */
      printf ("Width is too big\n");
      for (y=0;y<512;y++) 
        for (x=0;x<512;x++) 
          if (mode==0 || mode==6)
            fwrite(&byte_buffer[(y+(numRows-512)/2)*512+x+(numCols-512)/2],
                   sizeof(BYTE),1,fp);     
          else if (mode==1) {
      /*      temp = convert(short_buffer[(y+(numRows-512)/2)*512+x+
				(numCols-512)/2],
                           max,min); */
            temp = convert(short_buffer[y*numCols+x],
                           max,min); 
            fwrite(&temp,sizeof(BYTE),1,fp);     
          }
    } /* End width is too big */
  } /* End if height is too big */
  fclose(fp);
}



/****************************************************************
 *   write_MAP_Fortran takes one argument filename which is the name
 *   of the file that it is to open for writeing the MAP to
 ****************************************************************/
void write_MAP_Fortran(char *filename, float map_minH, float map_maxH)
{/* WRITE_MAP_FORTRAN */
  int i,j,k;
  FILE *fp;
  char ans[10];
  fString_t fname;
  short *itmp;
  char *s1;

  printf ("Entering write_MAP_Fortran\n");

  if(fp=fopen(filename,"r")) {
    printf ("File already exists!!!  Do you wish to overwrite it? ");
    gets(ans);
    tolower(ans[0]);
    if (ans[0]!='y') {
      fclose(fp);
      exit(0); 
    }
    fclose(fp);
  }

  fname.addr = (char *)malloc(sizeof(char)*64);
  fname.length = 64;
  fname.type = 14;
  fname.class = 1;
  s1= fname.addr;
  for(i=0;i<64;i++)
    s1[i]= ' ';
  sprintf(fname.addr,"%s",filename);

  itmp = (short *)malloc(sizeof(short)*numCols);
#ifdef VMS
  map_write_brant(&fname, short_buffer, 
		  &numCols, &numRows, &numSecs,
		  itmp, &floatScaleFactor,
		  &map_minH, &map_maxH, 
		  &aoverb, &map_abang,
		  &a_cell,&b_cell,&c_cell,
		  &alp,&bet,&gam,
		  t_matrix);
#endif
  free(itmp);

} /* End  WRITE_MAP_FORTRAN */



/****************************************************************
 *   write_MAP takes one argument filename which is the name
 *   of the file that it is to open for writeing the MAP to
 ****************************************************************/
void write_MAP(char *filename)
{
  FILE *fp;
  char ans[10];
  int temp;
  short zero=0;
  float f_zero=0.0;
  char string[72];
  int x,y,z;
  int img_min_int,img_max_int;
  char maxRecStr[80];
  int thisMaxRecordSize;

  printf ("Entering write_MAP\n");

  if(fp=fopen(filename,"r")) {
    printf ("File already exists!!!  Do you wish to overwrite it? ");
    gets(ans);
    tolower(ans[0]);
    if (ans[0]!='y') {
      fclose(fp);
      exit(0); 
    }
    fclose(fp);
  }
#ifdef VMS
  thisMaxRecordSize = (numCols*2)+2;
  sprintf(maxRecStr,"MRS=%d",thisMaxRecordSize);
  fp=fopen(filename,"w","rfm=var","rat=none",maxRecStr);
#else   
  fp = fopen(filename,"w");
#endif
  temp = -3;
  if (writeendianSwitch) {
    diffEndian((BYTE *)&temp,4);
    diffEndian((BYTE *)&zero,2);
    diffEndian((BYTE *)&f_zero,4);
    diffEndian((BYTE *)&numCols,4);
    diffEndian((BYTE *)&numRows,4);
    diffEndian((BYTE *)&numSecs,4);
    diffEndian((BYTE *)&img_min,4);
    diffEndian((BYTE *)&img_max,4);
    diffEndian((BYTE *)&aoverb,4);
    diffEndian((BYTE *)&map_abang,4);
    diffEndian((BYTE *)&map_scalef,4);
  }
    
  fwrite(&zero,sizeof(short),1,fp);
  fwrite(&temp,sizeof(int),1,fp); /* Write a -3 in here to signify a MAP file */
  fwrite(&zero,sizeof(short),1,fp);
  sprintf(string,"%s","map2pif"); 
  fwrite(string,sizeof(char)*72,1,fp);
  fwrite(&zero,sizeof(short),1,fp);
  fwrite(&numCols,sizeof(int),1,fp);
  fwrite(&numRows,sizeof(int),1,fp);
  fwrite(&numSecs,sizeof(int),1,fp);
  img_min_int = (int)(img_min*recipFloatScaleFactor);
  img_max_int = (int)(img_max*recipFloatScaleFactor);
  fwrite(&img_min_int,sizeof(int),1,fp);
  fwrite(&img_max_int,sizeof(int),1,fp);
  fwrite(&aoverb,sizeof(float),1,fp);
  fwrite(&map_abang,sizeof(float),1,fp);
  fwrite(&map_scalef,sizeof(float),1,fp);
  fwrite(&zero,sizeof(short),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&zero,sizeof(short),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&f_zero,sizeof(float),1,fp);
  fwrite(&zero,sizeof(short),1,fp);

  printf ("Writing MAP image %s...\n",filename); 
  for (x=0;x<numSecs;x++) {
    for (y=0;y<numRows;y++) {
      /* Write it row by row */ 
      if (writeendianSwitch) {
        for (z=0;z<numCols;z++) {
          diffEndian((BYTE *)&short_buffer[(x*numCols*numRows)+
					(y*numCols)+z],2);
        } /* For all Columns */
      } /* If write to Big endian machine */
      fwrite(&short_buffer[(numCols*numRows*x)+(numCols*y)],
             sizeof(short)*(numCols+1),1,fp);
    } /* For all Rows */
  } /* For all Sections */
} /* End write_MAP */

/****************************************************************
 *         read_Map reads in an old TSB MAP format and obtains
 *         values for numCols, numRows, and numSecs as well as
 *         new values for map_scalef, map_abang, and aoverb 
 ****************************************************************/
void read_MAP(char *filename) {
  FILE *fp;
  int x,y,z,n,i;
  short junk1,junk2;
  float junk;
  int file_id1,file_id2;
  char title[72];
  char maxRecStr[80];
  int thisMaxRecordSize;

  if (!(fp=fopen(filename,"r"))) {
    printf("Error: Opening %s\n",filename);
    exit(0);
  }
  determineFileType(fp);
#ifdef ISTHISAVALIDTESTFORINPUT
  if (mode!=20 && mode !=21) {  /* If not TSB MAP mode */
    printf ("Error: Not a Map file.\n");
    exit(0);
  }
#endif
  if (fileType!=MAP) {
    printf ("Error: Not a MAP file\n");
    exit(0);
  }

  fread(title,sizeof(char),72,fp);
  memcpy(descriptionStr,title,64);
  fread(&junk1,sizeof(short),1,fp);

  /* Read the number of Rows and Columns and Sections */
  fread(&numCols,sizeof(int),1,fp);
  fread(&numRows,sizeof(int),1,fp);
  fread(&numSecs,sizeof(int),1,fp);

  /* Get the min and max values in the file as well as the aoverb, mapabang
     and map_scalef */
  fread(&map_min,sizeof(float),1,fp);
  fread(&map_max,sizeof(float),1,fp);
  fread(&aoverb,sizeof(int),1,fp);
  fread(&map_abang,sizeof(int),1,fp);
  if (fileType==MAP) 
    fread(&map_scalef,sizeof(int),1,fp);


  if (readendianSwitch) {
    diffEndian((BYTE *)&numCols,4);
    diffEndian((BYTE *)&numRows,4);
    diffEndian((BYTE *)&numSecs,4);
    diffEndian((BYTE *)&map_min,4);
    diffEndian((BYTE *)&map_max,4);
    diffEndian((BYTE *)&map_scalef,4);
  }

  printf ("%d %d\n",img_min,img_max);
  /* Just read in all the reamaining header information and ignore it */
  fread(&junk1,sizeof(short),1,fp);       /* EOR */
  fread(&a_cell,sizeof(float),1,fp);
  fread(&b_cell,sizeof(float),1,fp);
  fread(&c_cell,sizeof(float),1,fp);
  fread(&alp,sizeof(float),1,fp);
  fread(&bet,sizeof(float),1,fp);
  fread(&gam,sizeof(float),1,fp);
  fread(&junk1,sizeof(short),1,fp);       /* EOR */
  fread(&dela,sizeof(float),1,fp);
  fread(&delb,sizeof(float),1,fp);
  fread(&delc,sizeof(float),1,fp);
  for(i=0;i<6;i++)
    fread(&t_matrix[i],sizeof(int),1,fp);
  fread(&junk1,sizeof(short),1,fp);       /* EOR */

  /* Allocate space for the short buffer */
  short_buffer = (short *)malloc(sizeof(short)*numCols*
                                                numRows*numSecs*nimg);

  if (!short_buffer) { /* If buffer wasn't created */
    printf ("Error: Couldn't allocate buffer\n");
    exit(0);
  } 

  /* Now lets read in the image */
  printf ("Reading file %s...\n",filename);
  for (n=0;n<nimg;n++) {
    for (x=0;x<numSecs;x++) {
      for (y=0;y<numRows;y++) {

        /* Read it Row by Row */
        fread(&short_buffer[(n*numRows*numCols*numSecs)+
 				(numCols*numRows*x)+(numCols*y)],
              			sizeof(short),numCols,fp);

        fread(&junk1,sizeof(short),1,fp); /* Read in this eor marker at the 
                                             end of each line */

        /* This is just here in case we ever read from a file that was 
           created on a big endian machine and we need to convert to 
           little endian first.  This should never happen but if neccessary 
           we would have to switch readendianSwitch to TRUE at some point in
           main to reflect that we have a big endian file */
        if (readendianSwitch) {
          for (z=0;z<numCols;z++) {
            diffEndian((BYTE *)&short_buffer[
			(n*numCols*numRows*numSecs)+(x*numRows*numCols)+
			(y*numCols)+z],2);
          } /* For all columns */
        } /* If readendianSwitch */
      } /* For all rows */
    } /* For all sections */
  } /* For all images */
  fclose(fp); /* Close the file */
} /* End read_MAP */



/*********************************************************************
 * readBPfile() - 
*/
void readBPfile(char *inFileName)
{/* READIMAGE */
  typedef unsigned char SIGNEDBYTE;
  int file_id,done,restBufLength,logicalRecordLength,m,k,l;
  int i,j;
  short shortJunk;
  int sysError;
  BYTE inBuf[2048];
  unsigned short shortPixel;
  BYTE bytePixel;
  SIGNEDBYTE *inBuffer;
  int writeSize;
  int titleLen;
  short title[65],shortNrow,shortNcol;
  char s1[1256];
  FILE *fDbug,*fIn;
  float minVal,maxVal,scaleFactor;
  int indcr,indr,indcrp1;
#define TRYFORTRAN
#ifdef TRYFORTRAN
#ifdef VMS
  sprintf(fileName.addr,"%s",inFileName);
  printf("[%s]\n",fileName.addr);

  choice = 'O';
  em_wrt = 0;
  lun = 9;

  open_bp (&fileName, &lun, &numCols, &numRows);
  byte_buffer = (BYTE *)malloc(sizeof(BYTE)*numCols*numRows);
  read_bp (&fileName, &lun, byte_buffer, &numCols, &numRows);
  return;


#else
  printf("We don't read BP except on VMS\n");
  exit(0);
#endif
#endif /*#ifdef TRYFORTRAN */


/*	  OPEN(UNIT=2,FILE=BPFILE,DEFAULTFILE='.BP',TYPE='OLD',
     1	       FORM='UNFORMATTED')
C	  *************************
C	  *  Read .BP image file  *
C	  *************************
*/

  fIn= fopen(inFileName,"r");

/*
	  READ(2)TITLEN
	  READ(2)(TITLE(I),I=1,TITLEN)
	  READ(2)numRows
	  READ(2)numCols
*/
  fread(&shortJunk,sizeof(short),1,fIn);  /* EOR marker */
  fread(&titleLen,sizeof(int),1,fIn);  
  fread(&shortJunk,sizeof(short),1,fIn);  /* EOR marker */
  for(i=0;i<titleLen;i++)
    fread(&title[i],sizeof(short),1,fIn);  
  fread(&shortJunk,sizeof(short),1,fIn);  /* EOR marker */

  fread(&numRows,sizeof(int),1,fIn);  
  fread(&shortJunk,sizeof(short),1,fIn);  /* EOR marker */
  fread(&numCols,sizeof(int),1,fIn);  
  fread(&shortJunk,sizeof(short),1,fIn);  /* EOR marker */

  printf("[%d][%d]\n",numRows,numCols);

  byte_buffer = (BYTE *)malloc(sizeof(BYTE)*numCols*numRows);
  inBuffer = (SIGNEDBYTE *)malloc(sizeof(char)*numCols*2);

  minVal = 9999.0;
  maxVal = -9999.0;
  for(j=0;j<numRows;j++)
    {/* rowes */

      indr = j*numCols;

#ifdef ORIGINAL
      fread((byte_buffer+(numCols*j)),sizeof(BYTE),(numCols+4),fIn);
#else
      fread(inBuffer,sizeof(SIGNEDBYTE),(numCols+4),fIn);
#endif
      fread(&shortJunk,sizeof(short),1,fIn); /* EOR marker */
                       
      /* Get rid of the EOR markers in the data - they appear
       * after 2042 bytes and they are shorts - so take away 
       * two bytes */
      for(i=4086;i<(numCols-1);i++)
	{/* Move them down */
	  indcr = i;
	  indcrp1 = i+1;
	  inBuffer[indcr]= inBuffer[indcrp1];
	}/* Move them down */

      for(i=4086;i<(numCols-1);i++)
	{/* Move them down */
	  indcr = i;
	  indcrp1 = i+1;
	  inBuffer[indcr]= inBuffer[indcrp1];
	}/* Move them down */

      for(i=2042;i<(numCols-1);i++)
	{/* Move them down */
	  indcr = i;
	  indcrp1 = i+1;
	  inBuffer[indcr]= inBuffer[indcrp1];
	}/* Move them down */

      for(i=2042;i<(numCols-1);i++)
	{/* Move them down */
	  indcr = i;
	  indcrp1 = i+1;
	  inBuffer[indcr]= inBuffer[indcrp1];
	}/* Move them down */

      for(i=0;i<numCols;i++)
	{/* cols */
	  int myInt;
	  indcr = (indr)+i;
	  myInt = (int)inBuffer[i];
	  if(myInt < 0)
	    {/* Found one */
printf("Old val[%d]  ",inBuffer[i]); 
	      byte_buffer[indcr]= (BYTE)(256 + (inBuffer[i]));
	    }/* Found one */
	  else byte_buffer[indcr]= (BYTE)(inBuffer[i]);


	  if(byte_buffer[indcr] < minVal)
	    minVal = byte_buffer[indcr];
	  if(byte_buffer[indcr] > maxVal)
	    maxVal = byte_buffer[indcr];

	}/* cols */

    }/* rowes */

#ifdef NEEDED
  scaleFactor = 127.0 / (maxVal-minVal);
  printf("minval[%f]  maxval[%f]  scale[%f]\n",minVal,maxVal,scaleFactor);

  for(j=0;j<numRows;j++)
    {/* rowes */
      indr = j*numCols;
      for(i=0;i<numCols;i++)
	{/* cols */
	  indcr = (indr)+i;

	  byte_buffer[indcr] = (BYTE)(((float)byte_buffer[indcr]-minVal) * 
				      scaleFactor);
	}/* cols */
    }/* rowes */
#endif /*#ifdef NEEDED */

  nimg= 1;        /* We only have one for these */

  free(inBuffer);
  fclose(fIn);

}/* READBPFILE */


